///////////////////////////////////////////////////////////
////// G Pascal pascal_math.c
////// Released under the GPL
////// Written by:
//////    Michael Gibson
//////    (c)2003
///////////////////////////////////////////////////////////

char variable_names[256][256];
char variable_type[256];
char value_of_variables[256][256];


///////////////////////////////////////////////////////////
////// math_set()
///////////////////////////////////////////////////////////
int math_set(char *command,int debug)
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  int x;
  int numofints=0;
 
  char char_value[15][15];
  int i_return;

  int value[5]={0};
   

  char operation[5];
  int numofops=0;

  strncpy(operation,"     \0",6);

    do{
      loop++;
    }while(command[loop] != '=');
    loop++;

  do{
    do{
      char_value[loop2][loop3]=command[loop];
     
      loop++;
      loop3++;
    }while(command[loop]!='+'&&command[loop]!='-'&&command[loop]!='*'&&command[loop]!='/'&&command[loop]!=';');
    char_value[loop2][loop3]='\0';

    for(x=0;x<=256;x++){
      if (strstr(char_value[loop2],variable_names[x])!='\0' && strlen(variable_names[x])>=1){
          strcpy(char_value[loop2],value_of_variables[x]);
      }
    }

    if(command[loop]=='+'){
       operation[numofops]='+';
       numofops++;
       loop++;
    }

    if(command[loop]=='-'){
       operation[numofops]='-';
       numofops++;
       loop++;
    }

    if(command[loop]=='/'){
       operation[numofops]='/';
       numofops++;
       loop++;
    }

    if(command[loop]=='*'){
       operation[numofops]='*';
       numofops++;
       loop++;
    }

    value[numofints]=atoi(char_value[loop2]);

    loop2++;
    loop3=0;

    numofints++;

  }while(command[loop] !=';');


  if(debug==1)printf("**[math_set] value 0=%d operation 0=%c value 1=%d \n",value[0],operation[0],value[1]); 

  if (operation[0]=='+') i_return = value[0] + value[1]; 

  if (operation[0]=='-') i_return = value[0] - value[1];

  if (operation[0]=='*') i_return = value[0] * value[1];

  if (operation[0]=='/') i_return = value[0] * value[1];


  if (operation[1]!=' '){

      if (operation[1]=='+') i_return = i_return + value[2];

      if (operation[1]=='-') i_return = i_return - value[2];

      if (operation[1]=='*') i_return = i_return * value[2];

      if (operation[1]=='/') i_return = i_return / value[2];

  }

  if (operation[2]!=' '){
                                                                                                                             
      if (operation[2]=='+') i_return = i_return + value[3];
                                                                                                                             
      if (operation[2]=='-') i_return = i_return - value[3];
                                                                                                                             
      if (operation[2]=='*') i_return = i_return * value[3];
                                                                                                                             
      if (operation[2]=='/') i_return = i_return / value[3];
                                                                                                                             
  }


  return(i_return);

}

//////////////////////////////////////////////////
//////isOperator()
/////////////////////////////////////////////////
int isOperator(char *check_char)
{
    if ((check_char[0]=='+') || 
        (check_char[0]=='-') || 
        (check_char[0]=='*') || 
        (check_char[0]=='/') || 
        (check_char[0]=='!') || 
        (check_char[0]=='=')) return 1;
    else return 0;
}

//////////////////////////////////////////////////
//////isLetter()
//////////////////////////////////////////////////
int isLetter(char check_char) {
	int i = (int) check_char - 97;
	if ((i>=0)&&(i<26)) return 1;
        else return 0;
}

/////////////////////////////////////////////////////
////// isOperand
/////////////////////////////////////////////////////
int isOperand(char *check_char)
{
    if (check_char[0] == '\0') // Reject an empty string
        return 0;
 
    if ( (check_char[0] == '-') || (check_char[0] == '+') ) // Check for leading sign
    {   
	return 1;
    }
    else return 0;

}

///////////////////////////////////////////////////////
////// calculate
///////////////////////////////////////////////////////
int calculate(char *op1, char *op, char *op2) 
{
  int o1=0,o2=0; 
  int i_return;

  switch(op[0])
    {
        case '+':    
                 i_return = o1 + o2;
                 break;
        case '-':    
                 i_return = o1 - o2;
                 break;
        case '*':    
                 i_return = o1 * o2;
                 break;
        case '/':    
                 i_return = o1 / o2;
                 break;
    }
  return i_return;

}

